import { jsx as _jsx } from "react/jsx-runtime";
import { errorId } from '@rjsf/utils';
import { List } from '@fluentui/react';
/** The `FieldErrorTemplate` component renders the errors local to the particular field
 *
 * @param props - The `FieldErrorProps` for the errors being rendered
 */
export default function FieldErrorTemplate(props) {
    const { errors = [], idSchema } = props;
    if (errors.length === 0) {
        return null;
    }
    const id = errorId(idSchema);
    return _jsx(List, { id: id, items: errors });
}
//# sourceMappingURL=FieldErrorTemplate.js.map